import logging from "../logging";

export default async ({ task, taskService }) => {
  const variables = task.variables.getAll();

  try {
    //console.log(variables);

    await taskService.complete(task);
  } catch (error) {
    await logging({ error, variables, filename: __filename });
    await taskService.handleFailure(task, {
      errorMessage: error.message
    });
  }
};
