/* tslint:disable no-null-keyword */

import _ from 'lodash';
import axios from 'axios';

import logging from '../logging';

interface IConfig {
  COUCHBASESYNC_URL: string;
}

interface IData {
  worker: string;
}

export default async ({ task, taskService }) => {
  const variables: IConfig & IData = task.variables.getAll();

  try {
	/*
    const worker = JSON.parse(variables.worker);

    await axios({
      method: 'POST',
      url: variables.COUCHBASESYNC_URL + '/agroinvest/_user/',
      headers: {
        Accept: 'application/json',
        'Content-Type': 'application/json',
      },
      data: JSON.stringify({
        name: `worker.${worker.id}`,
        password: worker.id,
        admin_channels: [
          `greenhouse.${worker.greenhouseId}`,
	  `worker.${worker.id}`,
        ],
      }),
    })
      .then(r => console.log(`WORKER [${worker.id}]: OK`))
      .catch(e => console.error(`WORKER [${worker.id}] [${_.get(e, 'response.status', e.status)}]: NOT OK`))
      .then(r => {
        axios({
          method: 'PUT',
          url: variables.COUCHBASESYNC_URL + `/agroinvest/_user/worker.${worker.id}`,
          headers: {
            Accept: 'application/json',
            'Content-Type': 'application/json',
          },
          data: JSON.stringify({
            admin_channels: [
              `greenhouse.${worker.greenhouseId}`,
	      `worker.${worker.id}`,
            ],
          }),
        });
      });
     */

    await taskService.complete(task);
  } catch (error) {
    await logging({ error, variables, filename: __filename, type: 'WORKERCOUCHBASESYNC' });
    await taskService.handleFailure(task, {
      errorMessage: error.message
    });
  } finally {
  }
};
